#ifndef CONFIG_H
#define CONFIG_H

#define DRIVER_VERSION_WCHAR                            L"1.8.0.2"
#define DRIVER_VERSION                                  "1.8.0.2"
#define DRIVER_VERSION_CONST                            0x1802
#define DRIVER_REMOTE_VERSION_CONST                     0x0003// Que merda e esta???

#define DRIVER_AUTHOR                                   "Nuno Santos <nsantos@displax.com>"
#define DRIVER_DESC                                     "DISPLAX SKIN MULTITOUCH Driver"
#define DEVICE_NAME                                     "dpxmtt"

#define DPX_MAX_DEVICES                                 10

#ifdef WINDOWS
#define DPX_KERNEL_CONNECTION                           1
#endif

#ifdef LINUX
#ifdef QT_NO_DEBUG
#define DPX_KERNEL_CONNECTION                           1
#else
#define DPX_KERNEL_CONNECTION                           1
#endif
#endif

#ifdef MACOSX
#define DPX_KERNEL_CONNECTION                           0
#endif

#define DPX_STATE_DISCONNECTED                          0
#define DPX_STATE_CONNECTED                             1

#define DPX_BLOCK_MIN_DELTA_V1                          5
#define DPX_BLOCK_MIN_DELTA_V2                          0

#define DPX_DEFAULT_GAIN                                48
#define DPX_GAIN_MAX_VALUE                              96
#define DPX_GAIN_MIN_VALUE                              32

#define DPX_MAX_FALSE_TOUCHES_PER_SECOND                15
#define DPX_TIMEOUT_FOR_FALSE_TOUCHES_CALIBRATION       50*3
#define DPX_TIMEOUT_FOR_CONTINUOUS_TOUCHES_CALIBRATION  50*300

#define DPX_DEFAULT_NOISE_REDUCTION                     0

#define DPX_INTERVAL_FRAMES_BETWEEN_AUTO_SETUP          6500

#define DPX_MAX_CALIBRATION_ZONES                       36
#define DPX_MAX_FRAME_REPORT                            6300

#define DPX_FRAME_MAX_ROWS                              64
#define DPX_FRAME_MAX_COLS                              64
#define DPX_FRAME_MAX_SIZE                              (DPX_FRAME_MAX_ROWS * DPX_FRAME_MAX_COLS)

#define DPX_TOUCH_MAX_REPORTED_COUNT                    20
#define DPX_TOUCH_MAX_COUNT                             DPX_TOUCH_MAX_REPORTED_COUNT
#define DPX_BLOB_MAX_COUNT                              48
#define DPX_TOUCH_HISTORY_SIZE                          32

#define DPX_TRACKING_MAX_SEARCH_DISTANCE                300*300*2

#define DPX_VENDOR                                      0x226e
#define DPX_VENDOR_STR                                  "226e"
#define DPX_PRODUCT                                     0x0001
#define DPX_PRODUCT_STR                                 "0001"

#define DPX_REQUEST_PACKET_SIZE                         0x08

#define DPX_REQ_PARTIAL_CALIBRATION                     0x00
#define DPX_REQ_FULL_CALIBRATION                        0x01
#define DPX_REQ_SET_PARAMETER                           0x02
#define DPX_REQ_SET_TEST_MODE                           0x03
#define DPX_REQ_CLEAR_TEST_MODE                         0x04

#define DPX_OUT_ENDPOINT                                0x02
#define DPX_IN_ENDPOINT                                 0x86

#define DPX_CTR_HOST_TO_DEVICE_VENDOR_DEVICE            0x40

#ifdef DPX_PROFILE
#include <QTime>
#define DPX_PROFILE_BEGIN /* QTime counter; counter.start(); */ timeval tim; gettimeofday(&tim, NULL);double t1=tim.tv_sec+(tim.tv_usec/1000000.0);
#define DPX_PROFILE_END(SECTION) /* DPX_DEBUG(SECTION << counter.elapsed()); */ gettimeofday(&tim, NULL); double t2=tim.tv_sec+(tim.tv_usec/1000000.0); printf("%s took %.6lf seconds\n", SECTION, t2-t1); fflush(stdout);
#else
#define DPX_PROFILE_BEGIN
#define DPX_PROFILE_END(SECTION)
#endif

struct _DPX_DEVICE;
typedef struct _DPX_DEVICE DPX_DEVICE, *PDPX_DEVICE;

struct _DPX_CONTEXT;
typedef struct _DPX_CONTEXT DPX_CONTEXT, *PDPX_CONTEXT;

struct _DPX_SHARED_CONTEXT;
typedef struct _DPX_SHARED_CONTEXT DPX_SHARED_CONTEXT, *PDPX_SHARED_CONTEXT;


#endif // CONFIG_H
