#ifndef DPX_DEBUG_H
#define DPX_DEBUG_H

#if defined(LINUX_DRIVER)
    #include <linux/kernel.h>
    #define DPX_DEBUG(MSG) printk(KERN_INFO "%s",MSG)
#elif defined(WINDOWS_DRIVER)
    #define DPX_DEBUG(MSG)
#else
    #ifdef QT_DEBUG
        #include <QDebug>
        #define DPX_DEBUG(MSG) qDebug() << "[DEBUG]" << MSG;
        #define DPX_INFO(MSG) qDebug() << "[INFO]" << MSG;
        #define DPX_ERROR(MSG) qDebug() << "[ERROR]" << MSG;
    #else
        #define DPX_DEBUG(MSG)
        #define DPX_INFO(MSG)
        #define DPX_ERROR(MSG)
    #endif
#endif

#endif // DPX_DEBUG_H
