#ifndef TRACKING_H
#define TRACKING_H

#include "Blob.h"
#include "Config.h"
#include "Touch.h"

/* Enum */

#define DPX_TRACKING_UNASSIGNED -1
#define DPX_TRACKING_END_TOUCH -2
#define DPX_TRACKING_NEW_TOUCH -3

/* Structures */

typedef struct _DPX_TRACKING_DATA
{
    PDPX_BLOB Blobs[DPX_BLOB_MAX_COUNT];
    PDPX_TOUCH Touches[DPX_TOUCH_MAX_COUNT];
    long long Distance[DPX_BLOB_MAX_COUNT][DPX_TOUCH_MAX_COUNT];

    int BestTouchBlob[DPX_TOUCH_MAX_COUNT];
    int BestBlobTouch[DPX_BLOB_MAX_COUNT];

    long long BestDistance;

    int CurrentId;
    int BlobCount;
    int TouchCount;
} DPX_TRACKING_DATA, *PDPX_TRACKING_DATA;

typedef struct _DPX_TRACKING_STATE
{
    DPX_CALIBRATION_ZONE CalibrationZones[DPX_MAX_CALIBRATION_ZONES];

    int NumZones;
    int FalseTouches;
    int FalseTouchesCounter;
    int ContinuousTouchesCounter;
} DPX_TRACKING_STATE, *PDPX_TRACKING_STATE;

void DPXTrackingBegin(PDPX_DEVICE Device);
void DPXTrackingComputeDistances(PDPX_DEVICE Device);
void DPXTrackingSearchForBestMatch(PDPX_DEVICE Device);
void DPXTrackingEnd(PDPX_DEVICE Device);
void DPXTrackingInitialize(PDPX_DEVICE Device);
void DPXTrackingExecute(PDPX_DEVICE Device);

int DPXTrackingGetTrackId(PDPX_DEVICE Device);

#endif // TRACKING_H
